/*
 *  Head.cpp
 *  emptyExample
 *
 *  Created by Andrew Wallace on 9/14/11.
 *  Copyright 2011 Cool Town Inc. All rights reserved.
 *
 */

#include "Head.h"


//--------------------------------------------------------------
void Head::setup(){
	speed=0.01;
	
	pos.x=0;
	pos.y=0;
	x=0;
	y=0;
	
	angle=0;
	
	minDist=100;
}

//--------------------------------------------------------------
void Head::draw(){
	
	//draw the "neck"
	ofPushMatrix();
	ofTranslate(pos.x, pos.y);
	ofRotate(ofRadToDeg(bodyAngle));
	ofSetColor(146, 236, 0, 210);
	ofScale(0.7, 0.7);
	ofTriangle(20, 0, -20, 20, -20, -20);
	ofPopMatrix();
	
	//and the head
	ofPushMatrix();
	ofTranslate(pos.x, pos.y);
	ofRotate(ofRadToDeg(angle));
	ofScale(1.3, 1.3);
	ofSetColor(146, 236, 0, 210);
	ofTriangle(20, 0, -20, 20, -20, -20);
	
	//eyes
	ofSetColor(0, 0, 0, 210);
	ofCircle(-5, -5, 2);
	ofCircle(-5, 5, 2);
	
	ofPopMatrix();
	
	
	//Uncoment this section to see the unadjusted position of the head
	//ofSetColor(255, 0, 0);
	//ofCircle(x, y, 10);
	
}


//--------------------------------------------------------------
//the head should xeno to the target
void Head::update(float targetX, float targetY){
	
	
	//figure out where the xeno base position should be
	if (ofDist(x, y, targetX, targetY)>100){	//only let it get so close to the mouse
		x = (1-speed)*x + speed*targetX;
		y = (1-speed)*y + speed*targetY;
	}
	//set angle based on target position
	angle=atan2(targetY-y, targetX-x);
	
	
	//apply a sine wave based on the angle to create a snake motion
	float adjust=sin(ofGetElapsedTimef()*5.1);
	float adjust2=sin(ofGetElapsedTimef()*1);
	//adjust=0;
	
	//find the two points 90 degrees away from the direciton the segment is moving
	float dist=100;
	float xA=x+dist*cos(angle+PI/2);
	float yA=y+dist*sin(angle+PI/2);
	float xB=x+dist*cos(angle-PI/2);
	float yB=y+dist*sin(angle-PI/2);
	
	//select a point in between these two based on the adjustment
	pos.x=ofMap(adjust, -1, 1, xA, xB, true);
	pos.y=ofMap(adjust, -1, 1, yA, yB, true);
	//and make sure the head is looking at the mouse
	angle=atan2(targetY-pos.y, targetX-pos.x);
	
	//Aply some sine curve action to the base position as well
	float dist2=3;
	float xA2=x+dist2*cos(angle+PI/2);
	float yA2=y+dist2*sin(angle+PI/2);
	float xB2=x+dist2*cos(angle-PI/2);
	float yB2=y+dist2*sin(angle-PI/2);
	
	x=ofMap(adjust2, -1, 1, xA2, xB2, true);
	y=ofMap(adjust2, -1, 1, yA2, yB2, true);
	
	
}