/*
 *  Segment.cpp
 *  emptyExample
 *
 *  Created by Andrew Wallace on 9/14/11.
 *  Copyright 2011 Cool Town Inc. All rights reserved.
 *
 */

#include "Segment.h"

//--------------------------------------------------------------
void Segment::setup(){
	pos.x=0;
	pos.y=0;
	
	for (int i=0; i<5; i++)	prevPos.push_back(pos);
	
	angle=0;
}

//--------------------------------------------------------------
void Segment::update(ofPoint newPos, float newAngle){
	pos=newPos;
	angle=newAngle;
	
	//store the current position in the vector
	prevPos.push_back(pos);
	//bump the old values if it's too long
	if (prevPos.size()>5)	prevPos.erase(prevPos.begin());
	
	//get the speed as an average of these points
	speed=0;
	for (int i=1; i<prevPos.size(); i++){
		float tempSpeed=abs(ofDist(prevPos[i].x,prevPos[i].y,prevPos[i-1].x,prevPos[i-1].y));
		speed+=tempSpeed;
	}
	speed/=prevPos.size();
	
	
}

//--------------------------------------------------------------
void Segment::draw(){
	
	ofPushMatrix();
	ofTranslate(pos.x, pos.y);
	ofRotate(ofRadToDeg(angle));
	
	ofSetColor(0,125,28, 210);
	ofTriangle(20, 0, -20, 20, -20, -20);
	
	float scaleVal=ofMap(speed, 3, 12, 1.2, 0.2, true);
	//scaleVal=1;
	ofScale(1, scaleVal, 1);
	
	
	ofSetColor(146, 236, 0, 210);
	ofLine(20, 0, -40, 40);
	ofLine(20, 0, -40, -40);
	//ofRect(0, 0, 30, 30);
	
	ofPopMatrix();
	
	
}



