/********************************************************
 * Xeno Creature with CV
 * Andy Wallace
 * 2011
 *
 * He follows the biggest blob on screen
 * Right now, he tends to go after tummies
 ********************************************************/

#ifndef _TEST_APP
#define _TEST_APP

#include "ofMain.h"
#include "Creature.h"
#include "ofxOpenCv.h"

#define _USE_LIVE_VIDEO		// uncomment this to use a live camera
								// otherwise, we'll use a movie file



class testApp : public ofBaseApp{

	public:

		void setup();
		void update();
		void draw();

		void keyPressed  (int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void windowResized(int w, int h);

        #ifdef _USE_LIVE_VIDEO
		  ofVideoGrabber 		vidGrabber;
		#else
		  ofVideoPlayer 		vidPlayer;
		#endif

        ofxCvColorImage		colorImg;

        ofxCvGrayscaleImage 	grayImage;
		ofxCvGrayscaleImage 	grayBg;
		ofxCvGrayscaleImage 	grayDiff;

        ofxCvContourFinder 	contourFinder;

		int 				threshold;
		bool				bLearnBakground;
	
	int width;
	int height;
	
	int largestBlob;
	
	//postion and size of the clip we're taking each frame
	int clipX;
	int clipW;
	
	bool showImg;
	int counter;		//determines how long to wait between taking another shot


	Creature creature;
	float blobX, blobY;	//location of biggest blob's center
	float targetX;		//target of the creature
	float targetY;
};

#endif
